#include "orb_device.h"
#include "orb_translator.h"
#include "hid_keys.h"
#include "chart_4.h"

Logical_orb orb_buffer( SpaceOrb360 );
Orb_translator translator;
byte b;
boolean has_initialized_orb=false;

void setup()
{
  Serial.begin( 9600 );

  translator.set_axis_map( Axis_map_spaceorb_face );
  translator.set_polarity( Polarity_spaceorb_face );

  translator.set_gain( 3 );
  translator.set_sensitivity_table( sensitivity_4_chart );
  translator.set_precision_gain( -2 );
  translator.set_precision_mask( 0x01 );
}

void loop()
{
  orb_device.refresh();
  if  ( Serial.available() )
  {
    b = Serial.read();
    orb_buffer.add_byte( b );
    if ( orb_buffer.has_changed() )
    {
      translator.update(orb_buffer, orb_device);
    }
  }
}
