#include "orb_device.h"
#include "orb_translator.h"
#include "hid_keys.h"
#include "chart_4.h"

Logical_orb orb_buffer( SpaceOrb360 );
Orb_translator translator;
byte b;
boolean has_initialized_orb=false;

PROGMEM Axis_key_binding axis_key_bindings[] =
  {
    { 0, 0, 255, 0, KEY_A },
    { 0, 768, 1023, 0, KEY_D},
    { 1, 0, 255, 0, KEY_W},
    { 1, 768, 1023, 0, KEY_S},
    { 5, 0, 255, 0, KEY_Q },
    { 5, 768, 1023, 0, KEY_E }
  };

void setup()
{
  Serial.begin( 9600 );

  translator.set_axis_map( Axis_map_spaceorb_face );
  translator.set_polarity( Polarity_spaceorb_face );

  translator.set_axis_key_bindings( axis_key_bindings, 6 );

}

void loop()
{
  orb_device.refresh();
  if  ( Serial.available() )
  {
    b = Serial.read();
    orb_buffer.add_byte( b );
    if ( orb_buffer.has_changed() )
    {
      translator.update(orb_buffer, orb_device);
    }
  }
}
