#include "orb_device.h"
#include "orb_translator.h"
#include "hid_keys.h"
#include "chart_4.h"

Logical_orb orb_buffer( SpaceOrb360 );
Orb_translator translator;
byte b;
boolean has_initialized_orb=false;

PROGMEM Button_key_binding button_key_bindings[] = 
  {
    { 0x01 << 1, MOD_SHIFT_LEFT, 0 },
    { 0x01 << 2, 0, KEY_H },
    { 0x01 << 3, 0, KEY_E },
    { 0x01 << 4, 0, KEY_L },
    { 0x01 << 5, 0, KEY_O }
  };

void setup()
{
  Serial.begin( 9600 );

  translator.set_axis_map( Axis_map_spaceorb_face );
  translator.set_polarity( Polarity_spaceorb_face );

  translator.set_button_key_bindings( button_key_bindings, 5 );
}

void loop()
{
  orb_device.refresh();
  if  ( Serial.available() )
  {
    b = Serial.read();
    orb_buffer.add_byte( b );
    if ( orb_buffer.has_changed() )
    {
      translator.update(orb_buffer, orb_device);
    }
  }
}
